<?php

/* SETTINGS PAGE */

function ew_emm_settings() {
	global $user_ID, $wpdb;
	$options_variable = 'ew_emm_settings';
	
	if ( $_POST["reset_settings"] == 'Reset Settings to Default' ) {
		if ( delete_user_meta( $user_ID, $options_variable ) ) {
			echo '<div id="message" class="updated">Settings reset successfully.</div>';
		} else {
			echo '<div id="message" class="error">Error resetting settings.</div>';
		}
	}

	/* CHECK IF OPTION IS SET BEFORE SAVING */
	
	if ( ( $_POST["save_changes"] == 'Save Changes' ) && ( isset( $_POST['options_array'] ) ) ) {

		/* RETRIEVE THE OPTION VALUE FROM THE FORM */
		
		$ew_emm_settings = $_POST['options_array'];
		$new_array = array();
		foreach ( $ew_emm_settings as $item => $value ) {
			if ( ( $item == 'highly_recommended_plugins' ) || ( $item == 'other_recommended_plugins' ) ) {
				$new_value = array();
				$new_value = explode( "\n", $value );
				$new_array["$item"] = array();
			} else {
				$new_array["$item"] = '';
				$new_value = $value;
			}
			$new_array["$item"] = $new_value;
		}
		if ( update_user_meta( $user_ID, $options_variable, $new_array ) ) {
			echo '<div id="message" class="updated">Settings saved successfully.</div>';
		} else {
			echo '<div id="message" class="error">Error saving settings.</div>';
		}
	}
	
	$ew_emm_settings = get_user_meta( $user_ID, $options_variable, 1 );
	
	if ( !empty( $ew_emm_settings ) ) {
	
 		/* LOAD THE SAVED VALUE IF IT EXISTS */
		
		echo '<p><i>This menu allows you to change common settings. For the plugin settings, make sure each plugin is named by its plugin folder and is on its own line. For the styles, make sure you use valid CSS. Click "Save Changes" when you are finished.</i></p>';

		/* DISPLAY THE SETTINGS FORM */
	
		echo '<form action="' . $_SERVER["REQUEST_URI"] . '" method="POST">';
		echo '<table class="widefat">';
		foreach ( $ew_emm_settings as $item => $value ) {
			echo '<tr>';
			echo '<td>' . ew_emm_translate_to_display_text( $item ) . '</td>';
			echo '<td><textarea name="options_array[' . $item . ']" ';
			if ( is_array( $value ) ) {
				echo 'cols="30" rows="10">';
				echo implode( "\n", $value );
			} else {
				echo 'cols="30" rows="3">' . $value;
			}
			echo '</textarea></td>';
			echo '</tr>';
		}
		echo '</table><br /><br />';
		echo '<table width="100%">';
		echo '<tr><td width="50%"><input class="button-primary" type="submit" name="save_changes" value="Save Changes" /></td>';
		echo '<td width="50%"><input class="button-primary" type="submit" name="reset_settings" value="Reset Settings to Default" /></td></tr>';
		echo '</table>';
		echo '</form>';
	}
}

?>