<?php

/* SITE OPTIONS PAGE */

function ew_emm_site_options() {
	global $wpdb, $user_ID;
	$options_variable = 'ew_emm_sites_options';
	$ew_emm_sites_options = get_user_meta( $user_ID, $options_variable, 1 );

	/* DISPLAY THE SITE SELECTION DROP-DOWN */
	
	$output_value = '<h2>Edit Site Option Values</h2>';
	$output_value .= '<form action="' . $_SERVER["REQUEST_URI"] . '" method="POST">';
	$site_info = array('domain', 'blog_id');
	$result = $wpdb->get_results( "SELECT blog_id, domain FROM $wpdb->blogs WHERE deleted = 0 ORDER BY blog_id ASC" );
	
	/* GET CURRENT SELECTED SITE */
	
	if ( $site_id = $_POST["site_to_edit"] ) { 
		$domain_name = $wpdb->get_var( $wpdb->prepare( "SELECT domain FROM $wpdb->blogs WHERE blog_id = $site_id" ) );
	}
	$output_value .= '<select name="site_to_edit">';
	foreach ( $result as $row => $item ) {
		if ( in_array( $item->blog_id, ew_emm_get_site_ids_for_user( $user_ID, 'Administrator' ) ) ) {
			$output_value .= '<option value="' . $item->blog_id . '"';
			if ( $domain_name == $item->domain ) { 
				$output_value .= ' selected="selected"';
			}
			$output_value .= '>' . $item->domain . '</option>';
		}
	}
	$output_value .= '</select> ';
	$output_value .= '<input type="checkbox" id="set_to_default" name="set_to_default" value="Set to Default" /> <label for="set_to_default">Apply Default Values</label> <input class="button-primary" type="submit" name="edit" value="Edit" /></form><br />';
	
	/* SAVE CHANGES BUTTON HAS BEEN CLICKED, UPDATING OPTIONS */
	
	if ( ( $_POST["save_site_settings"] == 'Save Changes' ) && ( $site_id = $_POST["site_to_edit"] ) ) {
		foreach ( $ew_emm_sites_options as $option_name => $option_properties ) {
			$update_option_name = $option_properties["option_name"];
			$update_option_value = $_POST[$update_option_name];
			$table = substr( $wpdb->prefix, 0, strpos( $wpdb->prefix, '_' ) + 1 ) . $site_id . '_options';
			$data = array( 'option_value' => $update_option_value );
			$where = array( 'option_name' => $update_option_name );
			$option_update_query = $table . ' ' . $data . ' ' . $where;
			if ( $update = $wpdb->update( $table, $data, $where ) ) { 
				$output_value .= '<i>The ' . $option_properties["display_name"] . ' option has been updated.</i><br />';
			}
		}
		$output_value .= '<br />';
	}
	if ( $_POST["set_to_default"] == 'Set to Default' ) { 
		$set_to_default = 1;
	}
	
	/* SITE HAS BEEN SELECTED, DISPLAYING OPTIONS */
	
	if ( $site_id = $_POST["site_to_edit"] ) {
		$site_options_table = substr( $wpdb->prefix, 0, strpos( $wpdb->prefix, '_' ) + 1 ) . $site_id . '_options';
		$result3 = $wpdb->get_results( "SELECT option_name, option_value FROM $site_options_table" );
		$temp_array = array();
		foreach ( $result3 as $row3 ) {
			$temp_array[$row3->option_name] = $row3->option_value;
		}
		$output_value .= '<b>Editing Options for ' . $domain_name . '</b><br /><br />';
		$output_value .= '<form action="' . $_SERVER["REQUEST_URI"] . '" method="POST">';
		$output_value .= '<input type="hidden" name="site_to_edit" value="' . $site_id . '" />';
		$output_value .= '<table cellspacing="0" cellpadding="0">';
		
		/* TABLE HEADINGS */
		
		$output_value .= '<tr><td><b>Option</b></td>';
		$output_value .= '<td><b>Value</b></td>';
		$output_value .= '<td>&nbsp;</td>';
		$output_value .= '<td>&nbsp;</td></tr>';
		
		/* TABLE ROWS: OPTION NAME, OPTION VALUE, RECOMMENDATIONS */
		
		foreach ( $ew_emm_sites_options as $option_name => $option_properties ) {
			$temp = $option_properties["option_name"];
			$actual_value = $temp_array["$temp"];
			$output_value .= '<tr><td>' . $option_properties["display_name"] . '</td>';
			if ( ( $set_to_default == 1 ) && array_key_exists( "alert_if_not_equal_to", $option_properties ) && ( $option_properties["alert_if_not_equal_to"] != '' ) && ( $option_properties["alert_if_not_equal_to"] != $actual_value ) ) {
				$output_value .= '<td><input type="text" name="' . $option_properties["option_name"] . '" size="60" style="background-color: yellow;" value="' . $option_properties["alert_if_not_equal_to"] . '" /></td><td>&nbsp;<img src="' . plugins_url( 'images/exclamation.png', dirname(__FILE__) ) . '" title="Current Value: ' . $actual_value . '" />&nbsp;</td>';
			} else {
				$output_value .= '<td><input type="text" name="' . $option_properties["option_name"] . '" size="60" value="' . $actual_value . '" /></td><td> </td>';
			}
			$output_value .= '<td>&nbsp;<img src="' . plugins_url( 'images/help.png', dirname(__FILE__) ) . '" title="' . $option_properties["explanation"] . '" />&nbsp;</td>';
			$output_value .= '</tr>';
		}
		
		/* SAVE CHANGES BUTTON */
		
		$output_value .= '<tr><td colspan="100%">';
		$output_value .= '<input class="button-primary" type="submit" name="save_site_settings" value="Save Changes" />';
		$output_value .= '</td></tr>';
		$output_value .= '</table></form><br />';
	}
	echo $output_value;
	
	/* SITE OPTIONS SETTINGS */
	
	$options_variable = 'ew_emm_sites_options';
	echo '<h2>Define Site Options</h2>';
	
	/* CHECK IF OPTION IS SET BEFORE SAVING */
  
	if ( isset( $_POST['options_array'] ) ) {

		/* RETRIEVE THE OPTION VALUE FROM THE FORM */
		
		$ew_emm_sites_options = $_POST['options_array'];
		$new_array = array();
		foreach ( $ew_emm_sites_options as $item => $value ) {
			if ( $value['option_name'] != '' ) {
				array_push( $new_array, $value );
			}
		}
		$new_array = ew_emm_subval_sort( $new_array, "display_order" );
		if ( update_user_meta( $user_ID, $options_variable, $new_array ) ) {
			echo '<div id="message" class="updated">Settings saved successfully.</div>';
		} else {
			echo '<div id="message" class="error">Error saving settings.</div>';
		}
	}
 
 	/* LOAD THE SAVED VALUE IF IT EXISTS */
	
	$ew_emm_sites_options = get_user_meta( $user_ID, $options_variable, 1 );
	$ew_emm_sites_options = ew_emm_subval_sort( $ew_emm_sites_options, "display_order" );

	echo '<p><i>Enter the options you want to appear as columns on the Site Overview page. The Site ID, Link to Backend, Link to Frontend, and Plugins columns are automatically displayed by default. For each entry, you must include a valid "Option Name" or that entry will not be saved. If you want to add more entries, just click "Save Changes" and 5 more blank rows will appear.</i></p>';

	echo '<form action="' . $_SERVER["REQUEST_URI"] . '" method="POST">';
	echo '<table class="widefat">';
	echo '<thead><tr>';
	echo '<th>Order <img src="' . plugins_url( 'images/help.png', dirname(__FILE__) ) . '" title="The numerical order in which this column should appear." style="vertical-align:middle;" /></th>';
	echo '<th>Show? <img src="' . plugins_url( 'images/help.png', dirname(__FILE__) ) . '" title="Whether or not to display this column." style="vertical-align:middle;" /></th>';
	echo '<th>Display Name <img src="' . plugins_url( 'images/help.png', dirname(__FILE__) ) . '" title="The column heading for this option." style="vertical-align:middle;" /></th>';
	echo '<th>Option Name <img src="' . plugins_url( 'images/help.png', dirname(__FILE__) ) . '" title="The option name (option_name field) in your options table." style="vertical-align:middle;" /></th>';
	echo '<th>Alert If Not Equal To <img src="' . plugins_url( 'images/help.png', dirname(__FILE__) ) . '" title="The default value you normally use for this option. If the actual option value for a site does not match this value, it will be highlighted on the Site Overview page." style="vertical-align:middle;" /></th>';
	echo '<th>Alert If Equal To <img src="' . plugins_url( 'images/help.png', dirname(__FILE__) ) . '" title="The value you do not want to use for this option. If the actual option value for a site matches this value, it will be highlighted on the Site Overview page." style="vertical-align:middle;" /></th>';
	echo '<th>Explanation <img src="' . plugins_url( 'images/help.png', dirname(__FILE__) ) . '" title="The explanation for this column, which appears when you hover over the help icon next to the column heading." style="vertical-align:middle;" /></th>';
	echo '</tr></thead>';
	$i = 0;
	foreach ( $ew_emm_sites_options as $item => $value ) {
		if ( $value['option_name'] != '' ) {
			echo '<tr>';
			echo '<td><input type="text" name="options_array[' . $i . '][' . 'display_order' . ']" size="5" value="' . $value['display_order'] . '"/></td>';
			echo '<td><input type="checkbox" name="options_array[' . $i . '][' . 'show' . ']"';
			if ( $value['show'] == 'on' ) {
				echo ' checked="checked"';
			}
			echo ' /></td>';
			echo '<td><input type="text" name="options_array[' . $i . '][' . 'display_name' . ']" size="30" value="' . $value['display_name'] . '"/></td>';
			echo '<td><input type="text" name="options_array[' . $i . '][' . 'option_name' . ']" size="30" value="' . $value['option_name'] . '"/></td>';
			echo '<td><input type="text" name="options_array[' . $i . '][' . 'alert_if_not_equal_to' . ']" size="30" value="' . $value['alert_if_not_equal_to'] . '"/></td>';
			echo '<td><input type="text" name="options_array[' . $i . '][' . 'alert_if_equal_to' . ']" size="30" value="' . $value['alert_if_equal_to'] . '"/></td>';
			echo '<td><textarea name="options_array[' . $i . '][' . 'explanation' . ']" cols="30" rows="3">' . $value['explanation'] . '</textarea></td>';
			echo '</tr>';
			$i++;
		}
	}
	$k = $i + 5;
	for ( $j=$i;$j<$k;$j++ ) {
		echo '<tr>';
		echo '<td><input type="text" name="options_array[' . $j . '][' . 'display_order' . ']" size="5" value=""/></td>';
		echo '<td><input type="checkbox" name="options_array[' . $j . '][' . 'show' . ']" /></td>';
		echo '<td><input type="text" name="options_array[' . $j . '][' . 'display_name' . ']" size="30" value=""/></td>';
		echo '<td><input type="text" name="options_array[' . $j . '][' . 'option_name' . ']" size="30" value=""/></td>';
		echo '<td><input type="text" name="options_array[' . $j . '][' . 'alert_if_not_equal_to' . ']" size="30" value=""/></td>';
		echo '<td><input type="text" name="options_array[' . $j . '][' . 'alert_if_equal_to' . ']" size="30" value=""/></td>';
		echo '<td><textarea name="options_array[' . $j . '][' . 'explanation' . ']" cols="30" rows="3"></textarea></td>';
		echo '</tr>';
	}
	echo '</table><br /><br />';
	echo '<input class="button-primary" type="submit" name="save_changes" value="Save Changes" />';
	echo '</form>';
}

?>