<?php

/* SITE OVERVIEW PAGE */

function ew_emm_site_overview() {

	/* DECLARE VARIABLES */
	
	global $user_ID, $wpdb;
	$options_variable = 'ew_emm_sites_options';
	$site_options = get_user_meta( $user_ID, $options_variable, 1 );
	$options_variable = 'ew_emm_settings';
	$ew_emm_settings = get_user_meta( $user_ID, $options_variable, 1 );
	$result = $wpdb->get_results( "SELECT blog_id, domain FROM $wpdb->blogs WHERE deleted = 0 ORDER BY blog_id ASC" );
	
	/* DEFINE STYLES */
	
	echo '<style type="text/css"> #ew_emm_table td { vertical-align:top; } ';
	echo '.alert_style {' . $ew_emm_settings['alert_styles'] . '} ';
	echo '.highly_recommended_plugin_style {' . $ew_emm_settings['highly_recommended_plugins_styles'] . '} ';
	echo '.other_recommended_plugin_style {' . $ew_emm_settings['other_recommended_plugins_styles'] . '} </style>';
	
	/* DISPLAY MAIN TABLE */
	
	echo '<table id="ew_emm_table" class="widefat">';
	
	/* DISPLAY TABLE HEADERS */
	
	echo '<thead><tr><th>Site ID</th><th>Size</th><th>Link to Backend</th><th>Link to Frontend</th>';
	foreach ( $site_options as $item => $value ) {
		if ( ( $value['option_name'] != '' ) && ( $value['show'] == 'on' ) ) {
			echo '<th>' . $value['display_name'] . ' <img src="' . plugins_url( 'images/help.png', dirname(__FILE__) ) . '" title="' . $value['explanation'] . '" style="vertical-align:middle;" /></th>';
		}
	}
	echo '<th>Plugins</th></tr></thead>';
	
	/* DISPLAY SITES AS TABLE ROWS */
	
	foreach ( $result as $row ) {
		
		/* GET SITE OPTION VALUES */
		
		$site_options_table = substr( $wpdb->prefix, 0, strpos( $wpdb->prefix, '_' ) + 1 ) . $row->blog_id . '_options';
		$temp = 'SELECT option_name, option_value FROM ' . $site_options_table . ' WHERE ';
		foreach ( $site_options as $item => $value ) {
			if ( $value['option_name'] != '' ) {
				$temp .= 'option_name = "' . $value['option_name'] . '" OR ';
			}
		}
		$temp .= 'option_name = "active_plugins"';
		$result2 = $wpdb->get_results( $temp );
		$result3 = array();
		foreach ( $result2 as $row2 ) {
			$result3[$row2->option_name] = $row2->option_value;
		}
		
		/* DISPLAY SITE ID */
		
		echo '<tr><td>' . $row->blog_id . '</td>';
		
		/* DISPLAY SIZE */
		
		$dir = ABSPATH . 'wp-content/blogs.dir/' . $row->blog_id;
		echo '<td>' . intval( get_dirsize( $dir ) / 1024 / 1024 ) . 'MB' . '</td>';
		
		/* DISPLAY LINK TO BACKEND */
		
		echo '<td><a href="http://' . $row->domain . '/wp-admin/" target="_blank">Backend</a></td>';
		
		/* DISPLAY LINK TO FRONTEND */
		
		echo '<td><a href="http://' . $row->domain . '" target="_blank">' . $row->domain . '</a></td>';
		
		/* DISPLAY VALUES FOR SITE OPTIONS */
		
		foreach ( $site_options as $item => $value ) {
			if ( ( $value['option_name'] != '' ) && ( $value['show'] == 'on' ) ) {
				$temp_option_name = $value['option_name'];
				if ( ( ( $result3[$temp_option_name] !== $value['alert_if_not_equal_to'] ) && ( $value['alert_if_not_equal_to'] != '' ) ) || ( ( $result3[$temp_option_name] === $value['alert_if_equal_to'] ) && ( $value['alert_if_equal_to'] != '' ) ) ) {
					echo '<td><span class="alert_style">' . $result3[$temp_option_name] . '</span></td>';
				} else {
					echo '<td>' . $result3[$temp_option_name] . '</td>';
				}
			}
		}
		
		/* GET PLUGIN VALUES */
		
		$active_plugins = array();
		$plugins = explode( '"', $result3['active_plugins'] );
		foreach ( $plugins as $plugin ) {
			if ( strpos( $plugin, "/" ) != FALSE ) {
				array_push( $active_plugins, substr( $plugin, 0, strpos( $plugin, "/" ) ) );
			}
		}
		
		/* DISPLAY VALUES FOR PLUGINS */
		
		echo '<td style="min-width:150px;">';
		
		/* DISPLAY LIST OF MISSING HIGHLY RECOMMENDED PLUGINS */
		
		$temp_array = array_diff( $ew_emm_settings['highly_recommended_plugins'], $active_plugins );
		if ( !empty( $temp_array ) ) {
			foreach ( $temp_array as $plugin ) {
				echo '<span class="highly_recommended_plugin_style">&nbsp;[' . $plugin . ']&nbsp;</span><br />';
			}
		}
		
		/* DISPLAY LIST OF MISSING RECOMMENDED PLUGINS */
		
		$temp_array = array_diff( $ew_emm_settings['other_recommended_plugins'], $active_plugins );
		if ( !empty( $temp_array ) ) {
			foreach ( $temp_array as $plugin ) {
				echo '<span class="other_recommended_plugin_style">&nbsp;[' . $plugin . ']&nbsp;</span><br />';
			}
		}
		
		/* DISPLAY LIST OF REMAINING ACTIVE PLUGINS */
		
		$temp_array = array_diff( $active_plugins, $ew_emm_settings['highly_recommended_plugins'], $ew_emm_settings['other_recommended_plugins'] );
		if ( !empty( $temp_array ) ) {
			foreach ( $temp_array as $plugin ) {
				echo $plugin . '<br />';
			}
		}
		echo '</td>';
	}
	echo '</tr></table>';
}

?>